/* LED8x8_MAX7219_LedControl
 * Fényújság 1 db MAX7219 meghajtóval vezérelt 8x8-as LED mátrixon.
 * Az inicializálás után előre megadott szöveget görgetünk a kijelzőn.
 * A MAX7219 vezérlése szofveres SPI meghajtással és a LedControl
 * programkönyvtár függvényeivel történik.
 */
#include "LedControl.h"
#include "english_6x8_pixel.h"

#define DATA_PIN    P2_3        // data for AS1106
#define CLOCK_PIN   P2_5        // clock for AS1106
#define LOAD_PIN    P2_4        // load CS for AS1106
const char line1[] = "LED8x8_MAX7219_LedControl example program ";
// Proto: LedControl(int dataPin, int clkPin, int csPin, int numDevices=1);
LedControl lc=LedControl(DATA_PIN, CLOCK_PIN, LOAD_PIN, 1);

void setup() {
  delay(1000);
  pinMode(DATA_PIN,OUTPUT);
  pinMode(CLOCK_PIN,OUTPUT);
  pinMode(LOAD_PIN,OUTPUT);
  digitalWrite(LOAD_PIN,HIGH);
  lc.init();
  lc.shutdown(0,false);
  lc.setIntensity(0,10);
  lc.clearDisplay(0);
}

void loop() {
  showText((char*)line1);
}

void scrollinRow(int data) {
  for(int r=0; r<7; r++) {
    lc.setRow(0,r,lc.getRow(0,r+1));
  }  
  lc.setRow(0,7,data);
}  

void writeChar(char ch) {
  ch -= 32;             //Start numbering from space
  for (int line=0; line<6; line++) {
    scrollinRow(font6x8[ch][line]); //write ont row
    delay(100);
  }
} 

void showText(const char *s) {
  while(*s) {
    writeChar(*s);
    s++;
  }  
}

