/* LED8x8_MAX7219_shiftOut
 * 8x8-as LED mátrix kipróbálása MAX7219 meghajtással
 * Az inicializálás után két karaktert felváltva villogtatunk
 * A MAX7219 vezérlése szofveres SPI meghajtással (lásd shiftOUT() 
 * függvény) történik. A program könnyen módosítható hardveres támogatású
 * SPI kezeléshez.
 */

#include "Energia.h"
//#include "SPI.h"
const int SPI_CS  = P2_4;                   //SPI Chip select    (LED CS bemenetre)
const int SPI_DIN = P2_3;                   //SPI MOSI adatvonal (LED DIN bemenetre)
const int SPI_CLK = P2_5;                   //SPI CLK órajel     (LED CLK bemenetre)

const unsigned char led1[]= {
  0x0,0x41,0x22,0x14,0x1C,0x14,0x22,0x41};  //X karakter
const unsigned char led2[]= {
  0xFF,0x81,0x81,0x81,0x81,0x81,0x81,0xFF}; //Négyzet alakú jel


void setup() {
  pinMode(SPI_CS,OUTPUT);                   //SPI_CS kimenet inicializálása
  digitalWrite(SPI_CS,HIGH);
  pinMode(SPI_CLK,OUTPUT);                  //SPI_CLK kimenet inicializálása
  digitalWrite(SPI_CLK,LOW);  
  pinMode(SPI_DIN,OUTPUT);                  //SPI_DIN kimenet inicializálása
  digitalWrite(SPI_DIN,LOW);
  //  SPI.begin();
  //  SPI.setClockDivider(SPI_CLOCK_DIV4);
  //  SPI.setBitOrder(MSBFIRST);
  //  SPI.setDataMode(SPI_MODE0);   
  Init_MAX7219();                           //LED vezérlő bekonfikurálása
}

void loop (){
  for(int i=1; i<9; i++)                    //Első karakter (8 sor) kiírása 
    SPI_Write2(i,led1[i-1]);
  delay(1000);                              //1 s várakozása  
  for(int i=1; i<9; i++)                    //Második karakter (8 sor) kiírása
    SPI_Write2(i,led2[i-1]);
  delay(1000);                              //1 s várakozása 

}

/* Két bájt kiküldése */
void SPI_Write2(unsigned char MSB, unsigned char LSB) 
{
  digitalWrite(SPI_CS,LOW);
  shiftOut(SPI_DIN,SPI_CLK,MSBFIRST,MSB);  
  shiftOut(SPI_DIN,SPI_CLK,MSBFIRST,LSB);  
  // SPI.transfer(MSB);
  // SPI.transfer(LSB);
  digitalWrite(SPI_CS,HIGH);   
}

/* A LED vezérlő IC konfigurálása */
void Init_MAX7219(void)
{
  SPI_Write2(0x09, 0x00);       //Dekódolást kikapcsolni
  SPI_Write2(0x0A, 0x08);       //Közepes fényerő beállítása
  SPI_Write2(0x0B, 0x07);       //Pásztázási korlát beállítása
  SPI_Write2(0x0C, 0x01);       //Megjelenítési mód beállítása
  SPI_Write2(0x0F, 0x0F);       //Display teszt engedélyezés
  delay(500);
  SPI_Write2(0x01, 0x00);       //0. sor törlése
  SPI_Write2(0x02, 0x00);       //1. sor törlése
  SPI_Write2(0x03, 0x00);       //2. sor törlése
  SPI_Write2(0x04, 0x00);       //3. sor törlése
  SPI_Write2(0x05, 0x00);       //4. sor törlése
  SPI_Write2(0x06, 0x00);       //5. sor törlése
  SPI_Write2(0x07, 0x00);       //6. sor törlése
  SPI_Write2(0x08, 0x00);       //7. sor törlése
  SPI_Write2(0x0F, 0x00);       //Display teszt tiltás  
  delay(500);
}




